/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.stresstestingreporttemplates;

import cdac.medinfo.sdk.dcm30_04.baselibs.ContentSequenceItem;
import cdac.medinfo.sdk.dcm30_04.srtree.SRTree;
import cdac.medinfo.sdk.dcm30_04.templates.cid.MajorCoronaryArteries_CID3016;
import cdac.medinfo.sdk.dcm30_04.templates.cid.NMExtracardiacFindings_CID3116;
import cdac.medinfo.sdk.dcm30_04.templates.cid.PerfusionFindings_CID3120;
import cdac.medinfo.sdk.dcm30_04.templates.cid.PerfusionMorphology_CID3121;
import cdac.medinfo.sdk.dcm30_04.templates.cid.StressImagingQualityIssue_CID3115;
import cdac.medinfo.sdk.dcm30_04.templates.cid.StudyQuality_CID3114;
import cdac.medinfo.sdk.dcm30_04.templates.cid.VentricleIdentification_CID3463;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_MajorCoronaryArteries;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_NMExtracardiacFindings;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PerfusionFindings;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PerfusionMorphology;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_StressImagingQualityIssues;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_StressImagingSummary;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_StudyQuality;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_VentricleIdentification;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_StressImagingSummary;
import cdac.medinfo.sdk.dcm30_04.templates.generaltemplates.Measurement_TID300;
import cdac.medinfo.sdk.dcm30_04.templates.generaltemplates.NegationModifierPresenceOfFinding_TID1350;
import cdac.medinfo.sdk.dcm30_04.templates.generaltemplates.Template;

/**
 * This class represents StressImagingSummary_TID3317
 */
	public class StressImagingSummary_TID3317 extends Template
{
	
	/**
	 * Object of StudyQuality_CID3114
	 */
	private StudyQuality_CID3114 objStudyQualityCID3114;
	
	/**
	 * Object of StressImagingQualityIssue_CID3115
	 */
	private StressImagingQualityIssue_CID3115 objStressImagingQualityIssueCID3115;
	
	/**
	 * Object of NMExtracardiacFindings_CID3116
	 */
	private NMExtracardiacFindings_CID3116 objNMExtracardiacFindingsCID3116;
	
	/**
	 * Object of MajorCoronaryArteries_CID3016
	 */
	private MajorCoronaryArteries_CID3016 objMajorCoronaryArteriesCID3016;
	
	/**
	 * Object of PerfusionFindings_CID3120
	 */
	private PerfusionFindings_CID3120 objPerfusionFindingsCID3120;
	
	/**
	 * Object of VentricleIdentification_CID3463
	 */
	private VentricleIdentification_CID3463 objVentricleIdentificationCID3463;
	
	/**
	 * Object of PerfusionMorphology_CID3121
	 */
	private PerfusionMorphology_CID3121 objPerfusionMorphologyCID3121;
	
	/**
	 * Object of Measurement_TID300
	 */
	private Measurement_TID300 objMeasurementTID300;
	
	/**
	 * Object of NegationModifierPresenceOfFinding_TID1350
	 */
	private NegationModifierPresenceOfFinding_TID1350 objNegationModifierPresenceOfFindingTID1350;
	
	/**
	 * Instantiates a new StressImagingSummary_TID3317 Template.
	 * @param objTree Object of SRTree.
	 */
	public StressImagingSummary_TID3317(SRTree objTree)
	{
		super(objTree);
	}

	/**
	 * Retrieves Negation Modifier Presence Of Finding.
	 * @return objNegationModifierPresenceOfFindingTID1350 Object of NegationModifierPresenceOfFinding_TID1350 
	 */
	public NegationModifierPresenceOfFinding_TID1350 getNegationModifierPresenceOfFinding()
	{
		if(null == this.objNegationModifierPresenceOfFindingTID1350)
			this.objNegationModifierPresenceOfFindingTID1350 = new NegationModifierPresenceOfFinding_TID1350(getSRTree());
		return this.objNegationModifierPresenceOfFindingTID1350;
	}
	
	/**
	 * Retrieves Measurement.
	 * @return objMeasurementTID300 Object of Measurement_TID300 
	 */
	public Measurement_TID300 getMeasurement()
	{
		if(null == this.objMeasurementTID300)
			this.objMeasurementTID300 = new Measurement_TID300(getSRTree());
		return this.objMeasurementTID300;
	}
	
	/**
	 * Sets the value for Finding Site.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setFindingSite(int[] arrPosition, EnumCM_MajorCoronaryArteries enumMajorCoronaryArteries )
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressImagingSummary.FINDING_SITE.getValue();
		String strCodeValue = EnumCV_StressImagingSummary.FINDING_SITE_G_C0E3.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		
		if(null== this.objMajorCoronaryArteriesCID3016)
			this.objMajorCoronaryArteriesCID3016 = new MajorCoronaryArteries_CID3016();
		this.objMajorCoronaryArteriesCID3016.setMajorCoronaryArteries(enumMajorCoronaryArteries);

		String strCM = objMajorCoronaryArteriesCID3016.getCodeMeaning();
		String strCV = objMajorCoronaryArteriesCID3016.getCodeValue();
		String strCSD = objMajorCoronaryArteriesCID3016.getCodingSchemeDesignator();
		String strSNOMEDCTID = objMajorCoronaryArteriesCID3016.getSNOMEDCTID();
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strCSDesg, strCV, strCM,strSNOMEDCTID);
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets the value for Myocardial perfusion.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setMyocardialPerfusion(int[] arrPosition, EnumCM_PerfusionFindings enumPerfusionFindings )
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressImagingSummary.MYOCARDIAL_PERFUSION.getValue();
		String strCodeValue = EnumCV_StressImagingSummary.MYOCARDIAL_PERFUSION_F_0238D.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		
		if(null== this.objPerfusionFindingsCID3120)
			this.objPerfusionFindingsCID3120 = new PerfusionFindings_CID3120();
		this.objPerfusionFindingsCID3120.setPerfusionFindings(enumPerfusionFindings);

		String strCM = objPerfusionFindingsCID3120.getCodeMeaning();
		String strCV = objPerfusionFindingsCID3120.getCodeValue();
		String strCSD = objPerfusionFindingsCID3120.getCodingSchemeDesignator();
		String strSNOMEDCTID = objPerfusionFindingsCID3120.getSNOMEDCTID();
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strCSDesg, strCV, strCM,strSNOMEDCTID);
		getSRTree().addChild(objContentSequenceItem);
	}
		
	/**
	 * Sets the value for Finding Site.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setFindingSite(int[] arrPosition, EnumCM_VentricleIdentification enumVentricleIdentification )
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressImagingSummary.FINDING_SITE.getValue();
		String strCodeValue = EnumCV_StressImagingSummary.FINDING_SITE_G_C0E3.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		
		if(null== this.objVentricleIdentificationCID3463)
			this.objVentricleIdentificationCID3463 = new VentricleIdentification_CID3463();
		this.objVentricleIdentificationCID3463.setVentricleIdentification(enumVentricleIdentification);

		String strCM = objVentricleIdentificationCID3463.getCodeMeaning();
		String strCV = objVentricleIdentificationCID3463.getCodeValue();
		String strCSD = objVentricleIdentificationCID3463.getCodingSchemeDesignator();
		String strSNOMEDCTID = objVentricleIdentificationCID3463.getSNOMEDCTID();
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strCSDesg, strCV, strCM,strSNOMEDCTID);
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets the value for Associated Morphology .
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setAssociatedMorphology(int[] arrPosition, EnumCM_PerfusionMorphology enumPerfusionMorphology)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressImagingSummary.ASSOCIATED_MORPHOLOGY.getValue();
		String strCodeValue = EnumCV_StressImagingSummary.ASSOCIATED_MORPHOLOGY_G_C504.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		if(null== this.objPerfusionMorphologyCID3121)
			this.objPerfusionMorphologyCID3121 = new PerfusionMorphology_CID3121();
		this.objPerfusionMorphologyCID3121.setPerfusionMorphology(enumPerfusionMorphology);

		String strCM = objPerfusionMorphologyCID3121.getCodeMeaning();
		String strCV = objPerfusionMorphologyCID3121.getCodeValue();
		String strCSD = objPerfusionMorphologyCID3121.getCodingSchemeDesignator();
		String strSNOMEDCTID = objPerfusionMorphologyCID3121.getSNOMEDCTID();
		
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strCSDesg, strCV, strCM,strSNOMEDCTID);
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets the value for Finding.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setFinding(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressImagingSummary.FINDING.getValue();
		String strCodeValue = EnumCV_StressImagingSummary.FINDING_121071.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.DCM.getValue();
		
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, "", strCSDesg, "", "","");
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Transient cavitary dilatation.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setTransientCavitaryDilatation(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressImagingSummary.TRANSIENT_CAVITARY_DILATATION.getValue();
		String strCodeValue = EnumCV_StressImagingSummary.TRANSIENT_CAVITARY_DILATATION_D4_31124.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, "", strCSDesg, "", "","");
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets the value for Coronary artery disease.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setCoronaryArteryDisease(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressImagingSummary.CORONARY_ARTERY_DISEASE.getValue();
		String strCodeValue = EnumCV_StressImagingSummary.CORONARY_ARTERY_DISEASE_D3_13040.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, "", strCSDesg, "", "","");
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for Finding.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setFinding(int[] arrPosition, EnumCM_NMExtracardiacFindings enumNMExtracardiacFindings)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressImagingSummary.FINDING.getValue();
		String strCodeValue = EnumCV_StressImagingSummary.FINDING_121071.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.DCM.getValue();
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		if(null== this.objNMExtracardiacFindingsCID3116)
			this.objNMExtracardiacFindingsCID3116 = new NMExtracardiacFindings_CID3116();
		this.objNMExtracardiacFindingsCID3116.setNMExtracardiacFindings(enumNMExtracardiacFindings);

		String strCM = objNMExtracardiacFindingsCID3116.getCodeMeaning();
		String strCV = objNMExtracardiacFindingsCID3116.getCodeValue();
		String strCSD = objNMExtracardiacFindingsCID3116.getCodingSchemeDesignator();
		String strSNOMEDCTID = objNMExtracardiacFindingsCID3116.getSNOMEDCTID();
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCV, strCSDesg, strCSD, strCM,strSNOMEDCTID);
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for Quality Issue.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setQualityIssue(int[] arrPosition, EnumCM_StressImagingQualityIssues enumStressImagingQualityIssues)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressImagingSummary.QUALITY_ISSUE.getValue();
		String strCodeValue = EnumCV_StressImagingSummary.QUALITY_ISSUE_113010.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.DCM.getValue();
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		if(null== this.objStressImagingQualityIssueCID3115)
			this.objStressImagingQualityIssueCID3115 = new StressImagingQualityIssue_CID3115();
		this.objStressImagingQualityIssueCID3115.setStressImagingQualityIssue(enumStressImagingQualityIssues);

		String strCM = objStressImagingQualityIssueCID3115.getCodeMeaning();
		String strCV = objStressImagingQualityIssueCID3115.getCodeValue();
		String strCSD = objStressImagingQualityIssueCID3115.getCodingSchemeDesignator();
		String strSNOMEDCTID = objStressImagingQualityIssueCID3115.getSNOMEDCTID();
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCV, strCSDesg, strCSD, strCM,strSNOMEDCTID);
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for Overall study quality.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setOverallStudyQuality(int[] arrPosition, EnumCM_StudyQuality enumStudyQuality)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressImagingSummary.QUALITY_ISSUE.getValue();
		String strCodeValue = EnumCV_StressImagingSummary.QUALITY_ISSUE_113010.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.DCM.getValue();
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		if(null== this.objStudyQualityCID3114)
			this.objStudyQualityCID3114 = new StudyQuality_CID3114();
		this.objStudyQualityCID3114.setStudyQuality(enumStudyQuality);

		String strCM = objStudyQualityCID3114.getCodeMeaning();
		String strCV = objStudyQualityCID3114.getCodeValue();
		String strCSD = objStudyQualityCID3114.getCodingSchemeDesignator();
		
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCV, strCSDesg, strCSD, strCM,"");
		getSRTree().addChild(objContentSequenceItem);
	}
}
